/**
 * BudgetOptimizer.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Mar 02, 2009 (07:08:06 PST) WSDL2Java emitter.
 */

package com.google.api.ads.adwords.axis.v201109_1.cm;


/**
 * In budget optimizer, Google automatically places bids for the user
 * based on their daily/monthly budget.
 */
public class BudgetOptimizer  extends com.google.api.ads.adwords.axis.v201109_1.cm.BiddingStrategy  implements java.io.Serializable {
    /* The enhanced CPC bidding option for the campaign, which enables
     * bids to be enhanced based on conversion optimizer data. For more
     *                     information about enhanced CPC, see the article
     * <a href="http://adwords.google.com/support/aw/bin/answer.py?answer=159957"
     * >What is Enhanced CPC?</a>.
     *                     <span class="constraint Selectable">This field
     * can be selected using the value "EnhancedCpcEnabled".</span><span
     * class="constraint Filterable">This field can be filtered on.</span> */
    private java.lang.Boolean enhancedCpcEnabled;

    /* Ceiling on bids placed by the budget optimizer.
     *                     <span class="constraint Selectable">This field
     * can be selected using the value "BidCeiling".</span> */
    private com.google.api.ads.adwords.axis.v201109_1.cm.Money bidCeiling;

    public BudgetOptimizer() {
    }

    public BudgetOptimizer(
           java.lang.String biddingStrategyType,
           java.lang.Boolean enhancedCpcEnabled,
           com.google.api.ads.adwords.axis.v201109_1.cm.Money bidCeiling) {
        super(
            biddingStrategyType);
        this.enhancedCpcEnabled = enhancedCpcEnabled;
        this.bidCeiling = bidCeiling;
    }


    /**
     * Gets the enhancedCpcEnabled value for this BudgetOptimizer.
     * 
     * @return enhancedCpcEnabled   * The enhanced CPC bidding option for the campaign, which enables
     * bids to be enhanced based on conversion optimizer data. For more
     *                     information about enhanced CPC, see the article
     * <a href="http://adwords.google.com/support/aw/bin/answer.py?answer=159957"
     * >What is Enhanced CPC?</a>.
     *                     <span class="constraint Selectable">This field
     * can be selected using the value "EnhancedCpcEnabled".</span><span
     * class="constraint Filterable">This field can be filtered on.</span>
     */
    public java.lang.Boolean getEnhancedCpcEnabled() {
        return enhancedCpcEnabled;
    }


    /**
     * Sets the enhancedCpcEnabled value for this BudgetOptimizer.
     * 
     * @param enhancedCpcEnabled   * The enhanced CPC bidding option for the campaign, which enables
     * bids to be enhanced based on conversion optimizer data. For more
     *                     information about enhanced CPC, see the article
     * <a href="http://adwords.google.com/support/aw/bin/answer.py?answer=159957"
     * >What is Enhanced CPC?</a>.
     *                     <span class="constraint Selectable">This field
     * can be selected using the value "EnhancedCpcEnabled".</span><span
     * class="constraint Filterable">This field can be filtered on.</span>
     */
    public void setEnhancedCpcEnabled(java.lang.Boolean enhancedCpcEnabled) {
        this.enhancedCpcEnabled = enhancedCpcEnabled;
    }


    /**
     * Gets the bidCeiling value for this BudgetOptimizer.
     * 
     * @return bidCeiling   * Ceiling on bids placed by the budget optimizer.
     *                     <span class="constraint Selectable">This field
     * can be selected using the value "BidCeiling".</span>
     */
    public com.google.api.ads.adwords.axis.v201109_1.cm.Money getBidCeiling() {
        return bidCeiling;
    }


    /**
     * Sets the bidCeiling value for this BudgetOptimizer.
     * 
     * @param bidCeiling   * Ceiling on bids placed by the budget optimizer.
     *                     <span class="constraint Selectable">This field
     * can be selected using the value "BidCeiling".</span>
     */
    public void setBidCeiling(com.google.api.ads.adwords.axis.v201109_1.cm.Money bidCeiling) {
        this.bidCeiling = bidCeiling;
    }

    private java.lang.Object __equalsCalc = null;
    public synchronized boolean equals(java.lang.Object obj) {
        if (!(obj instanceof BudgetOptimizer)) return false;
        BudgetOptimizer other = (BudgetOptimizer) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = super.equals(obj) && 
            ((this.enhancedCpcEnabled==null && other.getEnhancedCpcEnabled()==null) || 
             (this.enhancedCpcEnabled!=null &&
              this.enhancedCpcEnabled.equals(other.getEnhancedCpcEnabled()))) &&
            ((this.bidCeiling==null && other.getBidCeiling()==null) || 
             (this.bidCeiling!=null &&
              this.bidCeiling.equals(other.getBidCeiling())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = super.hashCode();
        if (getEnhancedCpcEnabled() != null) {
            _hashCode += getEnhancedCpcEnabled().hashCode();
        }
        if (getBidCeiling() != null) {
            _hashCode += getBidCeiling().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(BudgetOptimizer.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/cm/v201109_1", "BudgetOptimizer"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("enhancedCpcEnabled");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/cm/v201109_1", "enhancedCpcEnabled"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("bidCeiling");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/cm/v201109_1", "bidCeiling"));
        elemField.setXmlType(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/cm/v201109_1", "Money"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
